# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int
from typing import Literal, Optional

class MsgSvKillMsg(PrettyPrint):
    def __init__(
            self,
            chunk_header: Optional[ChunkHeader] = None,
            killer: int = 0,
            victim: int = 0,
            weapon: int = 0,
            mode_special: int = 0
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'game'
        self.message_name: str = 'sv_kill_msg'
        self.system_message: bool = False
        self.message_id: int = 4
        if not chunk_header:
            chunk_header = ChunkHeader(version = '0.6')
        self.header: ChunkHeader = chunk_header

        self.killer: int = killer
        self.victim: int = victim
        self.weapon: int = weapon
        self.mode_special: int = mode_special

    def __iter__(self):
        yield 'message_type', self.message_type
        yield 'message_name', self.message_name
        yield 'system_message', self.system_message
        yield 'message_id', self.message_id
        yield 'header', dict(self.header)

        yield 'killer', self.killer
        yield 'victim', self.victim
        yield 'weapon', self.weapon
        yield 'mode_special', self.mode_special

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.killer = unpacker.get_int()
        self.victim = unpacker.get_int()
        self.weapon = unpacker.get_int()
        self.mode_special = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.killer) + \
            pack_int(self.victim) + \
            pack_int(self.weapon) + \
            pack_int(self.mode_special)