# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int, pack_str
from typing import Literal, Optional

class MsgRconAuth(PrettyPrint):
    def __init__(
            self,
            chunk_header: Optional[ChunkHeader] = None,
            _unused: str = 'default',
            password: str = 'default',
            request_commands: int = 0
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'system'
        self.message_name: str = 'rcon_auth'
        self.system_message: bool = True
        self.message_id: int = 18
        if not chunk_header:
            chunk_header = ChunkHeader(version = '0.6')
        self.header: ChunkHeader = chunk_header

        self._unused: str = _unused
        self.password: str = password
        self.request_commands: Optional[int] = request_commands

    def __iter__(self):
        yield 'message_type', self.message_type
        yield 'message_name', self.message_name
        yield 'system_message', self.system_message
        yield 'message_id', self.message_id
        yield 'header', dict(self.header)

        yield '_unused', self._unused
        yield 'password', self.password
        yield 'request_commands', self.request_commands

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self._unused = unpacker.get_str()
        self.password = unpacker.get_str()
        self.request_commands = unpacker.get_optional_int()
        return True

    def pack(self) -> bytes:
        return pack_str(self._unused) + \
            pack_str(self.password) + \
            (pack_int(self.request_commands) if self.request_commands is not None else b'')