# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import SANITIZE_CC, pack_int, pack_str
from typing import Literal, Optional
import twnet_parser.enum7 as enum7

class MsgSvVoteSet(PrettyPrint):
    def __init__(
            self,
            chunk_header: Optional[ChunkHeader] = None,
            client_id: int = 0,
            type: int = enum7.Vote.UNKNOWN.value,
            timeout: int = 0,
            description: str = 'default',
            reason: str = 'default'
    ) -> None:
        self.message_type: Literal['system', 'game'] = 'game'
        self.message_name: str = 'sv_vote_set'
        self.system_message: bool = False
        self.message_id: int = 15
        if not chunk_header:
            chunk_header = ChunkHeader(version = '0.7')
        self.header: ChunkHeader = chunk_header

        self.client_id: int = client_id
        self.type: int = type
        self.timeout: int = timeout
        self.description: str = description
        self.reason: str = reason

    def __iter__(self):
        yield 'message_type', self.message_type
        yield 'message_name', self.message_name
        yield 'system_message', self.system_message
        yield 'message_id', self.message_id
        yield 'header', dict(self.header)

        yield 'client_id', self.client_id
        yield 'type', self.type
        yield 'timeout', self.timeout
        yield 'description', self.description
        yield 'reason', self.reason

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.client_id = unpacker.get_int()
        self.type = unpacker.get_int() # enum VOTE
        self.timeout = unpacker.get_int()
        self.description = unpacker.get_str(SANITIZE_CC)
        self.reason = unpacker.get_str(SANITIZE_CC)
        return True

    def pack(self) -> bytes:
        return pack_int(self.client_id) + \
            pack_int(self.type) + \
            pack_int(self.timeout) + \
            pack_str(self.description) + \
            pack_str(self.reason)