# generated by scripts/generate_messages.py
from typing import Optional

import twnet_parser.msg7
from twnet_parser.net_message import NetMessage
from twnet_parser.ddnet_uuid import MsgDDNetUuid

import twnet_parser.messages7.game.sv_motd as \
       game7_sv_motd
import twnet_parser.messages7.game.sv_broadcast as \
       game7_sv_broadcast
import twnet_parser.messages7.game.sv_chat as \
       game7_sv_chat
import twnet_parser.messages7.game.sv_team as \
       game7_sv_team
import twnet_parser.messages7.game.sv_kill_msg as \
       game7_sv_kill_msg
import twnet_parser.messages7.game.sv_tune_params as \
       game7_sv_tune_params
import twnet_parser.messages7.game.sv_extra_projectile as \
       game7_sv_extra_projectile
import twnet_parser.messages7.game.sv_ready_to_enter as \
       game7_sv_ready_to_enter
import twnet_parser.messages7.game.sv_weapon_pickup as \
       game7_sv_weapon_pickup
import twnet_parser.messages7.game.sv_emoticon as \
       game7_sv_emoticon
import twnet_parser.messages7.game.sv_vote_clear_options as \
       game7_sv_vote_clear_options
import twnet_parser.messages7.game.sv_vote_option_list_add as \
       game7_sv_vote_option_list_add
import twnet_parser.messages7.game.sv_vote_option_add as \
       game7_sv_vote_option_add
import twnet_parser.messages7.game.sv_vote_option_remove as \
       game7_sv_vote_option_remove
import twnet_parser.messages7.game.sv_vote_set as \
       game7_sv_vote_set
import twnet_parser.messages7.game.sv_vote_status as \
       game7_sv_vote_status
import twnet_parser.messages7.game.sv_server_settings as \
       game7_sv_server_settings
import twnet_parser.messages7.game.sv_client_info as \
       game7_sv_client_info
import twnet_parser.messages7.game.sv_game_info as \
       game7_sv_game_info
import twnet_parser.messages7.game.sv_client_drop as \
       game7_sv_client_drop
import twnet_parser.messages7.game.sv_game_msg as \
       game7_sv_game_msg
import twnet_parser.messages7.game.de_client_enter as \
       game7_de_client_enter
import twnet_parser.messages7.game.de_client_leave as \
       game7_de_client_leave
import twnet_parser.messages7.game.cl_say as \
       game7_cl_say
import twnet_parser.messages7.game.cl_set_team as \
       game7_cl_set_team
import twnet_parser.messages7.game.cl_set_spectator_mode as \
       game7_cl_set_spectator_mode
import twnet_parser.messages7.game.cl_start_info as \
       game7_cl_start_info
import twnet_parser.messages7.game.cl_kill as \
       game7_cl_kill
import twnet_parser.messages7.game.cl_ready_change as \
       game7_cl_ready_change
import twnet_parser.messages7.game.cl_emoticon as \
       game7_cl_emoticon
import twnet_parser.messages7.game.cl_vote as \
       game7_cl_vote
import twnet_parser.messages7.game.cl_call_vote as \
       game7_cl_call_vote
import twnet_parser.messages7.game.sv_skin_change as \
       game7_sv_skin_change
import twnet_parser.messages7.game.cl_skin_change as \
       game7_cl_skin_change
import twnet_parser.messages7.game.sv_race_finish as \
       game7_sv_race_finish
import twnet_parser.messages7.game.sv_checkpoint as \
       game7_sv_checkpoint
import twnet_parser.messages7.game.sv_command_info as \
       game7_sv_command_info
import twnet_parser.messages7.game.sv_command_info_remove as \
       game7_sv_command_info_remove
import twnet_parser.messages7.game.cl_command as \
       game7_cl_command

def match_game7(msg_id: int, data: bytes) -> NetMessage:
    msg: Optional[NetMessage] = None

    if msg_id == twnet_parser.msg7.SV_MOTD:
        msg = game7_sv_motd.MsgSvMotd()
    elif msg_id == twnet_parser.msg7.SV_BROADCAST:
        msg = game7_sv_broadcast.MsgSvBroadcast()
    elif msg_id == twnet_parser.msg7.SV_CHAT:
        msg = game7_sv_chat.MsgSvChat()
    elif msg_id == twnet_parser.msg7.SV_TEAM:
        msg = game7_sv_team.MsgSvTeam()
    elif msg_id == twnet_parser.msg7.SV_KILL_MSG:
        msg = game7_sv_kill_msg.MsgSvKillMsg()
    elif msg_id == twnet_parser.msg7.SV_TUNE_PARAMS:
        msg = game7_sv_tune_params.MsgSvTuneParams()
    elif msg_id == twnet_parser.msg7.SV_EXTRA_PROJECTILE:
        msg = game7_sv_extra_projectile.MsgSvExtraProjectile()
    elif msg_id == twnet_parser.msg7.SV_READY_TO_ENTER:
        msg = game7_sv_ready_to_enter.MsgSvReadyToEnter()
    elif msg_id == twnet_parser.msg7.SV_WEAPON_PICKUP:
        msg = game7_sv_weapon_pickup.MsgSvWeaponPickup()
    elif msg_id == twnet_parser.msg7.SV_EMOTICON:
        msg = game7_sv_emoticon.MsgSvEmoticon()
    elif msg_id == twnet_parser.msg7.SV_VOTE_CLEAR_OPTIONS:
        msg = game7_sv_vote_clear_options.MsgSvVoteClearOptions()
    elif msg_id == twnet_parser.msg7.SV_VOTE_OPTION_LIST_ADD:
        msg = game7_sv_vote_option_list_add.MsgSvVoteOptionListAdd()
    elif msg_id == twnet_parser.msg7.SV_VOTE_OPTION_ADD:
        msg = game7_sv_vote_option_add.MsgSvVoteOptionAdd()
    elif msg_id == twnet_parser.msg7.SV_VOTE_OPTION_REMOVE:
        msg = game7_sv_vote_option_remove.MsgSvVoteOptionRemove()
    elif msg_id == twnet_parser.msg7.SV_VOTE_SET:
        msg = game7_sv_vote_set.MsgSvVoteSet()
    elif msg_id == twnet_parser.msg7.SV_VOTE_STATUS:
        msg = game7_sv_vote_status.MsgSvVoteStatus()
    elif msg_id == twnet_parser.msg7.SV_SERVER_SETTINGS:
        msg = game7_sv_server_settings.MsgSvServerSettings()
    elif msg_id == twnet_parser.msg7.SV_CLIENT_INFO:
        msg = game7_sv_client_info.MsgSvClientInfo()
    elif msg_id == twnet_parser.msg7.SV_GAME_INFO:
        msg = game7_sv_game_info.MsgSvGameInfo()
    elif msg_id == twnet_parser.msg7.SV_CLIENT_DROP:
        msg = game7_sv_client_drop.MsgSvClientDrop()
    elif msg_id == twnet_parser.msg7.SV_GAME_MSG:
        msg = game7_sv_game_msg.MsgSvGameMsg()
    elif msg_id == twnet_parser.msg7.DE_CLIENT_ENTER:
        msg = game7_de_client_enter.MsgDeClientEnter()
    elif msg_id == twnet_parser.msg7.DE_CLIENT_LEAVE:
        msg = game7_de_client_leave.MsgDeClientLeave()
    elif msg_id == twnet_parser.msg7.CL_SAY:
        msg = game7_cl_say.MsgClSay()
    elif msg_id == twnet_parser.msg7.CL_SET_TEAM:
        msg = game7_cl_set_team.MsgClSetTeam()
    elif msg_id == twnet_parser.msg7.CL_SET_SPECTATOR_MODE:
        msg = game7_cl_set_spectator_mode.MsgClSetSpectatorMode()
    elif msg_id == twnet_parser.msg7.CL_START_INFO:
        msg = game7_cl_start_info.MsgClStartInfo()
    elif msg_id == twnet_parser.msg7.CL_KILL:
        msg = game7_cl_kill.MsgClKill()
    elif msg_id == twnet_parser.msg7.CL_READY_CHANGE:
        msg = game7_cl_ready_change.MsgClReadyChange()
    elif msg_id == twnet_parser.msg7.CL_EMOTICON:
        msg = game7_cl_emoticon.MsgClEmoticon()
    elif msg_id == twnet_parser.msg7.CL_VOTE:
        msg = game7_cl_vote.MsgClVote()
    elif msg_id == twnet_parser.msg7.CL_CALL_VOTE:
        msg = game7_cl_call_vote.MsgClCallVote()
    elif msg_id == twnet_parser.msg7.SV_SKIN_CHANGE:
        msg = game7_sv_skin_change.MsgSvSkinChange()
    elif msg_id == twnet_parser.msg7.CL_SKIN_CHANGE:
        msg = game7_cl_skin_change.MsgClSkinChange()
    elif msg_id == twnet_parser.msg7.SV_RACE_FINISH:
        msg = game7_sv_race_finish.MsgSvRaceFinish()
    elif msg_id == twnet_parser.msg7.SV_CHECKPOINT:
        msg = game7_sv_checkpoint.MsgSvCheckpoint()
    elif msg_id == twnet_parser.msg7.SV_COMMAND_INFO:
        msg = game7_sv_command_info.MsgSvCommandInfo()
    elif msg_id == twnet_parser.msg7.SV_COMMAND_INFO_REMOVE:
        msg = game7_sv_command_info_remove.MsgSvCommandInfoRemove()
    elif msg_id == twnet_parser.msg7.CL_COMMAND:
        msg = game7_cl_command.MsgClCommand()

    # msg_id 0 is used by ddnet uuid messages
    # do not crash on those
    if msg is None:
        if msg_id != 0:
            raise ValueError(f"Error: unknown game message id={msg_id} data={data[0]}")
        msg = MsgDDNetUuid()

    msg.unpack(data)
    return msg
