# generated by scripts/generate_messages.py

from typing import Any, Dict

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjGameData(PrettyPrint):
    def __init__(
            self,
            teamscore_red: int = 0,
            teamscore_blue: int = 0,
            flag_carrier_red: int = 0,
            flag_carrier_blue: int = 0
    ) -> None:
        self.item_name: str = 'item.game_data'
        self.type_id: int = 7
        self.id: int = 0
        self.size: int = 4

        self.teamscore_red: int = teamscore_red
        self.teamscore_blue: int = teamscore_blue
        self.flag_carrier_red: int = flag_carrier_red
        self.flag_carrier_blue: int = flag_carrier_blue

    def __iter__(self):
        yield 'item_name', self.item_name
        yield 'type_id', self.type_id
        yield 'id', self.id
        yield 'size', self.size

        yield 'teamscore_red', self.teamscore_red
        yield 'teamscore_blue', self.teamscore_blue
        yield 'flag_carrier_red', self.flag_carrier_red
        yield 'flag_carrier_blue', self.flag_carrier_blue

    def to_dict_payload_only(self) -> Dict[str, Any]:
        return {
            'teamscore_red': self.teamscore_red,
            'teamscore_blue': self.teamscore_blue,
            'flag_carrier_red': self.flag_carrier_red,
            'flag_carrier_blue': self.flag_carrier_blue
        }

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, unpacker: Unpacker) -> bool:
        self.teamscore_red = unpacker.get_int()
        self.teamscore_blue = unpacker.get_int()
        self.flag_carrier_red = unpacker.get_int()
        self.flag_carrier_blue = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.teamscore_red) + \
            pack_int(self.teamscore_blue) + \
            pack_int(self.flag_carrier_red) + \
            pack_int(self.flag_carrier_blue)