# generated by scripts/generate_messages.py

from typing import Any, Dict

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int
import twnet_parser.enum6 as enum6

class ObjSoundWorld(PrettyPrint):
    def __init__(
            self,
            sound_id: int = enum6.Sound.GUN_FIRE.value
    ) -> None:
        self.item_name: str = 'item.sound_world'
        self.type_id: int = 19
        self.id: int = 0
        self.size: int = 3

        self.sound_id: int = sound_id

    def __iter__(self):
        yield 'item_name', self.item_name
        yield 'type_id', self.type_id
        yield 'id', self.id
        yield 'size', self.size

        yield 'sound_id', self.sound_id

    def to_dict_payload_only(self) -> Dict[str, Any]:
        return {
            'sound_id': self.sound_id
        }

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, unpacker: Unpacker) -> bool:
        # common
        self.x = unpacker.get_int()
        self.y = unpacker.get_int()

        # sound_world
        self.sound_id = unpacker.get_int() # enum SOUND
        return True

    def pack(self) -> bytes:
        return pack_int(self.sound_id)