# generated by scripts/generate_messages.py

from typing import Any, Dict

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjDamage(PrettyPrint):
    def __init__(
            self,
            client_id: int = 0,
            angle: int = 0,
            health_amount: int = 0,
            armor_amount: int = 0,
            self_: bool = False
    ) -> None:
        self.item_name: str = 'item.damage'
        self.type_id: int = 22
        self.id: int = 0
        self.size: int = 7

        self.client_id: int = client_id
        self.angle: int = angle
        self.health_amount: int = health_amount
        self.armor_amount: int = armor_amount
        self.self_: bool = self_

    def __iter__(self):
        yield 'item_name', self.item_name
        yield 'type_id', self.type_id
        yield 'id', self.id
        yield 'size', self.size

        yield 'client_id', self.client_id
        yield 'angle', self.angle
        yield 'health_amount', self.health_amount
        yield 'armor_amount', self.armor_amount
        yield 'self_', self.self_

    def to_dict_payload_only(self) -> Dict[str, Any]:
        return {
            'client_id': self.client_id,
            'angle': self.angle,
            'health_amount': self.health_amount,
            'armor_amount': self.armor_amount,
            'self_': self.self_
        }

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, unpacker: Unpacker) -> bool:
        # common
        self.x = unpacker.get_int()
        self.y = unpacker.get_int()

        # damage
        self.client_id = unpacker.get_int()
        self.angle = unpacker.get_int()
        self.health_amount = unpacker.get_int()
        self.armor_amount = unpacker.get_int()
        self.self_ = unpacker.get_int() == 1
        return True

    def pack(self) -> bytes:
        return pack_int(self.client_id) + \
            pack_int(self.angle) + \
            pack_int(self.health_amount) + \
            pack_int(self.armor_amount) + \
            pack_int(self.self_)