# generated by scripts/generate_messages.py

from typing import Any, Dict

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.packer import pack_int

class ObjDeath(PrettyPrint):
    def __init__(
            self,
            client_id: int = 0
    ) -> None:
        self.item_name: str = 'item.death'
        self.type_id: int = 20
        self.id: int = 0
        self.size: int = 3

        self.client_id: int = client_id

    def __iter__(self):
        yield 'item_name', self.item_name
        yield 'type_id', self.type_id
        yield 'id', self.id
        yield 'size', self.size

        yield 'client_id', self.client_id

    def to_dict_payload_only(self) -> Dict[str, Any]:
        return {
            'client_id': self.client_id
        }

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, unpacker: Unpacker) -> bool:
        # common
        self.x = unpacker.get_int()
        self.y = unpacker.get_int()

        # death
        self.client_id = unpacker.get_int()
        return True

    def pack(self) -> bytes:
        return pack_int(self.client_id)